[UVA][二分答案] 12124 - Assemble
Problem A - Assemble
Time limit: 2 seconds
Recently your team noticed that the computer you use to practice for programming contests is not good enough anymore. Therefore, you decide to buy a new computer.
To make the ideal computer for your needs, you decide to buy separate components and assemble the computer yourself. You need to buy exactly one of each type of component.
The problem is which components to buy. As you all know, the quality of a computer is equal to the quality of its weakest component. Therefore, you want to maximize the quality of the component with the lowest quality, while not exceeding your budget.
Input
On the first line one positive number: the number of testcases, at most 100. After that per testcase:
- One line with two integers: 1 ≤ n ≤ 1000, the number of available components and 1 ≤ b ≤ 1000000000, your budget.
- n lines in the following format: ``type name price quality'', where type is a string with the type of the component, name is a string with the unique name of the component, price is an integer (0 ≤ price < 1000000) which represents the price of the component and quality is an integer (0 ≤ quality ≤ 1000000000) which represents the quality of the component (higher is better). The strings contain only letters, digits and underscores and have a maximal length of 20 characters.
It will always possible to construct a computer with your budget.
Output
Per testcase:
- One line with one integer: the maximal possible quality.
Sample Input
1 18 800 processor 3500_MHz 66 5 processor 4200_MHz 103 7 processor 5000_MHz 156 9 processor 6000_MHz 219 12 memory 1_GB 35 3 memory 2_GB 88 6 memory 4_GB 170 12 mainbord all_onboard 52 10 harddisk 250_GB 54 10 harddisk 500_FB 99 12 casing midi 36 10 monitor 17_inch 157 5 monitor 19_inch 175 7 monitor 20_inch 210 9 monitor 22_inch 293 12 mouse cordless_optical 18 12 mouse microsoft 30 9 keyboard office 4 10
Sample Output
9
題目描述:
購買一台電腦所需要的配備,每一種零件有很多種類可以挑選,各有其花費與品質。
由於電腦的速度,取決於所有硬體設備中最慢的硬體,同理考慮在品質,
想要最大化最小品質,而且預算有限,不能多花。
題目解法:
首先會有疑惑,零件有哪幾種?這個根據每組冊資去做決定,把相同種零件分一堆,
每種零件都要挑出一種就是了,二分品質,在同種零件中,找可達到品質得最小花費。
#include <stdio.h>
#include <string.h>
#include <iostream>
#include <map>
#include <vector>
using namespace std;
int main() {
int testcase, n, m;
int i, j;
scanf("%d", &testcase);
while(testcase--) {
scanf("%d %d", &n, &m);
map<string, vector<pair<int,int> > > R;
map<string, vector<pair<int,int> > >::iterator it;
vector<pair<int,int> >::iterator jt;
char TYPE[105];
int p, q;
for(i = 0; i < n; i++) {
scanf("%s %*s %d %d", TYPE, &p, &q);
R[TYPE].push_back(make_pair(p, q));
}
int l, r, mid;//binary search quality
int cost, onecost;
int ret = 0;
l = 0, r = 1000000000;
while(l <= r) {
mid = (l+r)/2;
cost = 0;
for(it = R.begin(); it != R.end(); it++) {
onecost = 1000000000;
for(jt = (it->second).begin(); jt != (it->second).end();
jt++) {
if(jt->second >= mid)
onecost = min(onecost, jt->first);
}
cost += onecost;
if(cost > m)
break;
}
if(cost <= m)
l = mid+1, ret = max(ret, mid);
else
r = mid-1;
}
printf("%d\n", ret);
}
return 0;
}